Attribute VB_Name = "basDSound02"
' DirectSoundCapture demo
' http://members.xoom.com/vba51

Option Explicit
    
Dim DirectSound As IDirectSound
Dim DirectSoundCapture As IDirectSoundCapture
Dim WaveFormat As WAVEFORMATEX
Dim CaptureBufferDesc As DSCBUFFERDESC
Dim CaptureBuffer As IDirectSoundCaptureBuffer
Dim DirectSoundBufferDesc As DSBUFFERDESC
Dim DirectSoundBuffer As IDirectSoundBuffer

Public Sub Initialize(ByVal hWnd As Long)
    ' Initialize DirectSound
    DirectSoundCreate ByVal 0&, DirectSound, Nothing
    DirectSound.SetCooperativeLevel hWnd, DSSCL_NORMAL
    With WaveFormat
        .nChannels = 1
        .wFormatTag = WAVE_FORMAT_PCM
        .nSamplesPerSec = 22050
        .nAvgBytesPerSec = 22050
        .nBlockAlign = 1
        .wBitsPerSample = 8
    End With
    With DirectSoundBufferDesc
        .dwSize = Len(DirectSoundBufferDesc)
        .dwFlags = DSBCAPS_CTRLDEFAULT
        .dwReserved = 0
        .lpwfxFormat = VarPtr(WaveFormat)
        .dwBufferBytes = WaveFormat.nAvgBytesPerSec
    End With
    DirectSound.CreateSoundBuffer DirectSoundBufferDesc, DirectSoundBuffer, Nothing
    ' Initialize DirectSoundCapture
    DirectSoundCaptureCreate ByVal 0&, DirectSoundCapture, Nothing
    With CaptureBufferDesc
        .dwSize = Len(CaptureBufferDesc)
        .dwFlags = 0
        .dwBufferBytes = WaveFormat.nAvgBytesPerSec
        .dwReserved = 0
        .lpwfxFormat = VarPtr(WaveFormat)
    End With
    DirectSoundCapture.CreateCaptureBuffer CaptureBufferDesc, CaptureBuffer, Nothing
End Sub

Public Sub Capture()
    Dim Status As Long
    ' Capture
    CaptureBuffer.Start 0
    Do
        CaptureBuffer.GetStatus Status
    Loop While (Status And DSCBSTATUS_CAPTURING)
    CaptureBuffer.Stop
    
    ' Copy capture buffer to sound buffer
    Dim CapturePtr1 As Long
    Dim CaptureLen1 As Long
    Dim CapturePtr2 As Long
    Dim CaptureLen2 As Long
    Dim PlayPtr1 As Long
    Dim PlayLen1 As Long
    Dim PlayPtr2 As Long
    Dim PlayLen2 As Long
    DirectSoundBuffer.Lock 0&, DirectSoundBufferDesc.dwBufferBytes, PlayPtr1, PlayLen1, PlayPtr2, PlayLen2, 0&
    CaptureBuffer.Lock 0&, CaptureBufferDesc.dwBufferBytes, CapturePtr1, CaptureLen1, CapturePtr2, CaptureLen2, 0&
    CopyMemory ByVal PlayPtr1, ByVal CapturePtr1, CaptureLen1
    CaptureBuffer.Unlock CapturePtr1, CaptureLen1, CapturePtr2, CaptureLen2
    DirectSoundBuffer.Unlock PlayPtr1, PlayLen1, PlayPtr2, PlayLen2
    
    ' Reset capture buffer :
    ' When using the Capture button for the second time,
    ' capture forever without this code !
    ' Same problem for your card ?
    Set CaptureBuffer = Nothing
    DirectSoundCapture.CreateCaptureBuffer CaptureBufferDesc, CaptureBuffer, Nothing
End Sub

Public Sub Play()
    Dim Status As Long
    DirectSoundBuffer.Play 0, 0, 0
    Do
        DirectSoundBuffer.GetStatus Status
    Loop While (Status And DSBSTATUS_PLAYING)
    DirectSoundBuffer.Stop
End Sub

Public Sub Terminate()
    Set CaptureBuffer = Nothing
    Set DirectSoundCapture = Nothing
    Set DirectSoundBuffer = Nothing
    Set DirectSound = Nothing
End Sub
